/* This file is part of IRadit.
   Copyright 2014, Victor Algaba <victor@radit.org> www.radit.org

   IRadit is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   Iradit is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Clementine.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <QDesktopWidget>
#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "setting/Setting.h"
#include "about/About.h"




MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);





    frmtoolbar = new ToolBar(this) ;
    toolbar= new QToolBar(this);
    toolbar->setMovable(false);


    toolbar->addWidget(frmtoolbar);

    //botonera barra de herramientas
        connect(frmtoolbar->BtnSetting,SIGNAL(clicked()),this, SLOT(ClickSetting()));  //Setting
        connect(frmtoolbar->BtnAcerca,SIGNAL(clicked()),this, SLOT(ClickAbout()));  //Setting


   Dock1= new Dock(this);
   Dock2= new Dock(this);
   DockMonitor= new Dock(this);


   player1 = new Player(this);
   player2 =new Player(this);
   playermonitor =new Player(this);


   player1->setTipo(Player::PlayerType1);
   player2->setTipo(Player::PlayerType2);
   playermonitor->setTipo(Player::PlayerTypeMonitor);

   tab = new Tab();



   Dock1->setWidget(player1);
   Dock2->setWidget(player2);
   DockMonitor->setWidget(playermonitor);




 this->addDockWidget(Qt::TopDockWidgetArea, Dock1,Qt::Horizontal);
 this->addDockWidget(Qt::TopDockWidgetArea, Dock2,Qt::Horizontal);
 this->addDockWidget(Qt::TopDockWidgetArea, DockMonitor,Qt::Horizontal);


 this->setCentralWidget(tab);
 this->addToolBar(toolbar);

}

MainWindow::~MainWindow()
{
   // delete player1;
    delete ui;
}


///////////////////////////////////////////
void MainWindow::ClickSetting(){

    Setting *setting = new Setting();
    setting->exec();
  //  delete setting;



}



void MainWindow::ClickAbout(){

    About *about = new About();
    about->exec();



}


void MainWindow::resizeEvent( QResizeEvent *event)
{

   // tab->setMaximumSize(this->size()); //limita el ancho

}




