/* This file is part of IRadit.
   Copyright 2014, Victor Algaba <victor@radit.org> www.radit.org

   IRadit is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   Iradit is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Clementine.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <QDebug>
#include <QMenu>
#include <QContextMenuEvent>
#include <QXmlStreamWriter>

#include "tab/Tab.h"
#include"button/Button.h"
#include"iostream/Iostream.h"



Tab::Tab(QWidget *parent): QDialog(parent)
{
 setupUi(this);

 //this->setMaximumSize(20000,200);


iostream = new Iostream;


load();

}


Tab::~Tab(){
    save();
    delete iostream;

}



void Tab::addPage(){

    int page= this->tabWidget->count()+1;

    QString pa;
    pa=pa.setNum(page);
    this->tabWidget->addTab(new QWidget(this),"Page " + pa);
    this->tabWidget->setCurrentIndex(this->tabWidget->count()-1);
    QGridLayout *layout = new QGridLayout(this->tabWidget->currentWidget());



     QString numero, nu;
     int linea=1;
     int bottonid=1;

 for(int co=0; co<=5; co++){  //columnas

    for(int c=1;c<=10;c++){  //filas
        nu.setNum(linea);

          if(linea<10)
             numero ="0" + nu;
            else
             numero = nu;

         Button *button = new Button(this);
         connect(button,SIGNAL(clicked()),this, SLOT(ClickButton()));

          if(c<6)
              button->setPlayer(Button::PlayerType1);
              else
              button->setPlayer(Button::PlayerType2);

         layout->addWidget(button,co,c);
         button->setText(numero);
         button->setNumero(numero);
         button->tab = this->tabWidget->count()-1;

         button->botonId=bottonid;
         //button->setObjectName("bu" + nu.setNum(this->tabWidget->count()-1));
         linea++;
         bottonid++;
     }


   }

   allButton = this->findChildren<Button *>();


}


void Tab::deletePage(){
   int  tab = this->tabWidget->count()-1;
  //if(tab==0) //no se puede borrar la pagina 1
    //  return;

  for (int i = 0; i < allButton.size(); ++i){
        if(allButton.at(i)->tab==tab)

           delete allButton.at(i);              //borramos objetos de la ficha
       }

 this->tabWidget->removeTab(tab); //borramos ficha

 allButton = this->findChildren<Button *>();  //creamos tabla


}


void Tab::ClickButton(){

    QObject* obj = QObject::sender();
    Button *Boton = qobject_cast<Button *>(obj);


}

void Tab::save(){

     this->setCursor(Qt::BusyCursor);

 //Iostream *iostream = new Iostream;

 iostream->setAllButton(allButton);
 iostream->setTabwidget(this->tabWidget);
 iostream->save();


 //delete iostream;

  this->setCursor(Qt::ArrowCursor);


}

void Tab::load(){


    this->setCursor(Qt::BusyCursor);

//Iostream *iostream = new Iostream;



iostream->createPestanas();

for (int i = 0; i < iostream->Pestanas; ++i)
addPage(); //aadimos las pginas

iostream->setAllButton(allButton);

iostream->load();



//delete iostream;

 this->setCursor(Qt::ArrowCursor);

}

void Tab::contextMenuEvent(QContextMenuEvent *event)
 {
    QMenu *menu = new QMenu(this);

     // QIcon *icono;
     // QAction *Act;



    menu->setStyleSheet(QString::fromUtf8("QMenu {\n"
                                          "\n"
                                          "background-color: qlineargradient(spread:pad, x1:0.994318, y1:1, x2:1, y2:0, stop:0.0113636 rgba(146, 169, 211, 255), stop:0.982955 rgba(174, 199, 230, 255));\n"
                                          "border-color: rgb(0, 0, 0);\n"
                                          "}\n"
                                          "QMenu::item {\n"
                                          "background-color: rgb(255, 255, 255);\n"
                                          "}\n"
                                          "QMenu::item:selected {\n"
                                          "background-color: qlineargradient(spread:pad, x1:1, y1:1, x2:1, y2:0, stop:0 rgba(129, 166, 226, 255), stop:1 rgba(93, 131, 190, 255));\n"
                                          "}"));





   /* openAct = new QAction(QIcon(":/images/open.png"), tr("&Open..."), this);
         openAct->setShortcuts(QKeySequence::Open);
         openAct->setStatusTip(tr("Open an existing file"));
         connect(openAct, SIGNAL(triggered()), this, SLOT(open()));

         fileMenu->addAction(openAct);*/

       QAction *actionAdd;
       actionAdd = new QAction("Aadit pgina",this);
       connect(actionAdd, SIGNAL(triggered()), this, SLOT(addPage()));
       menu->addAction(actionAdd);

       QAction *actionDelete;
       actionDelete = new QAction("Borrar ltima pgina",this);
       connect(actionDelete, SIGNAL(triggered()), this, SLOT(deletePage()));
       menu->addAction(actionDelete);


  menu->exec(event->globalPos());

delete menu;

}



void Tab::resizeEvent( QResizeEvent *event)
{



}






